<?php

namespace Ig\IgAccountCreate\Domain\Repository;

use TYPO3\CMS\Core\Crypto\PasswordHashing\PasswordHashFactory;
use TYPO3\CMS\Core\Database\ConnectionPool;
use TYPO3\CMS\Core\Utility\GeneralUtility;

class FrontendUserRepository
{
    public function createuser($email, $password, $hash, $newsleter, $pid, $usergroup)
    {
        $hashFactory = GeneralUtility::makeInstance(PasswordHashFactory::class);
        $hashInstance = $hashFactory->getDefaultHashInstance('FE');
        $hashedPassword = $hashInstance->getHashedPassword($password);

        $insertArray = [
            'pid' => $pid,
            'usergroup' => $usergroup,
            'username' => $email,
            'password' => $hashedPassword,
            'email' => $email,
            'disable' => 1,
            'tstamp' => time(),
            'crdate' => time(),
            'tx_extbase_type' => 'Tx_IgFemanager_FeUserExtendet',
            'description' => $hash,
        ];
        /*        if ( $newsleter ) {
                  $insertArray['module_sys_dmail_newsletter'] = 1;
                  $insertArray['module_sys_dmail_html'] = 1;

                  }
        */
        $queryBuilder = GeneralUtility::makeInstance(ConnectionPool::class)->getQueryBuilderForTable('fe_users');
        $affectedRows = $queryBuilder->insert('fe_users')
->values($insertArray)
->execute();
        //$res = $GLOBALS['TYPO3_DB']->exec_INSERTquery('fe_users', $insertArray);
    }

    public function enableUser($hash)
    {
        $queryBuilder = GeneralUtility::makeInstance(ConnectionPool::class)->getQueryBuilderForTable('fe_users');
        $affectedRows = $queryBuilder->update('fe_users')
->where(
    $queryBuilder->expr()
->neq('description', $queryBuilder->createNamedParameter('')),
    $queryBuilder->expr()
->eq('description', $queryBuilder->createNamedParameter($hash))
)
            ->set('disable', 0)
                       ->set('description', '')
            ->execute();
        return $affectedRows;
        /*
          'first_name' => $this->piVars['vorname'],
              'last_name' => $this->piVars['name'],
              'zip' => $this->piVars['plz'],
              'city' => $this->piVars['ort'],
              'telephone' => $this->piVars['telefon'],
              //'mobile' => $this->piVars['mobile'],
              'address' => $this->piVars['strasse'],
            'disable' => '0',
            'comments' => '',
        */
    }
    public function findOneByEmail($email)
    {
        $queryBuilder = GeneralUtility::makeInstance(ConnectionPool::class)->getQueryBuilderForTable('fe_users');
        $result = $queryBuilder
                ->select('uid')
                ->from('fe_users')
                ->where(
                    $queryBuilder->expr()
->eq('deleted', $queryBuilder->createNamedParameter(0, \PDO::PARAM_INT)),
                    $queryBuilder->expr()
->eq('email', $queryBuilder->createNamedParameter($email))
                )
                ->execute();
        return $result->fetch();
        /*
        $con=$GLOBALS['TYPO3_DB']->exec_SELECTquery( 'uid', 'fe_users', "deleted = 0 AND email=".$GLOBALS['TYPO3_DB']->fullQuoteStr($email,'fe_users')."", null,  null, null );
               $row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc( $con );
        */
    }

    public function findOneByComments($comments)
    {
        $queryBuilder = GeneralUtility::makeInstance(ConnectionPool::class)->getQueryBuilderForTable('fe_users');
        $result = $queryBuilder
                ->select('uid')
                ->from('fe_users')
                ->where(
                    $queryBuilder->expr()
->eq('deleted', $queryBuilder->createNamedParameter(0, \PDO::PARAM_INT)),
                    $queryBuilder->expr()
->eq('description', $queryBuilder->createNamedParameter($comments))
                )
                ->execute();
        return $result->fetch();
        /*
        $con=$GLOBALS['TYPO3_DB']->exec_SELECTquery( '*', 'fe_users', "deleted = 0 AND comments=".$GLOBALS['TYPO3_DB']->fullQuoteStr($hash,'fe_users')."", null,  null, null );
        */
    }
}
