<?php

namespace Ig\IgAccountCreate\Lib;

use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Frontend\ContentObject\ContentObjectRenderer;

class Utility
{
    public $prefixId = 'tx_igaccountcreate_pi1';		// Same as class name
    public $scriptRelPath = 'pi1/class.tx_igaccountcreate_pi1.php';	// Path to this script relative to the extension dir.
    public $extKey = 'ig_account_create';    // The extension key.


    public $form_felder_1 = [
        'p' => [
            'label' => 'Passwort',
            'type' => 'password',
            'mandatory' => 1,
        ],
    ];
    public $form_felder_2 = [
        'name' => [
            'label' => 'Name',
            'mandatory' => 1,
        ],
        'vorname' => [
            'label' => 'Vorname',
            'mandatory' => 1,
        ],
        'strasse' => [
            'label' => 'Strasse',
            'mandatory' => 1,
        ],
        'plz' => [
            'label' => 'PLZ',
            'mandatory' => 1,
        ],
        'ort' => [
            'label' => 'Ort',
            'mandatory' => 1,
        ],
        'telefon' => [
            'label' => 'Telefon',
            'mandatory' => 1,
            'description' => '(Wichitg für kurzfristige Kursabsagen)',
        ],
        'mobile' => [
            'label' => 'Natel',
            'mandatory' => 0,
            'description' => '(Wichitg für kurzfristige Kursabsagen)',
        ],
    ];
    protected $piVars = [];
    protected $sendcode = '';
    protected $sendcode_old = '';
    protected $errors = 0;
    protected $error_email = 0;
    protected $error_password = 0;
    protected $error_password_text = 0;
    protected $error_user_exists = 0;
    protected $error_agb = 0;
    protected $error_mandatory = 0;
    protected $settings = [];
                    
    public function parseRTE($value)
    {
        $parseFuncTSPath = 'lib.parseFunc_RTE';
        $contentObject = GeneralUtility::makeInstance(ContentObjectRenderer::class);
        $contentObject->start([]);
        $content = $contentObject->parseFunc($value, [], '< ' . $parseFuncTSPath);
        return $content;
    }

    public function generatePassword($len = 8, $list = '23456789ABCDEFGHJKMNPQRSTUVWXYZ')
    {
        $str = '';
        if (is_numeric($len) && !empty($list)) {
            mt_srand((float) microtime() * 1000000);
            while (strlen($str) < $len) {
                $str .= $list[mt_rand(0, strlen($list) - 1)];
            }
        }
        return $str;
    }


    public function get_register_form_1(
        $errors,
        $error_password_text,
        $error_password,
        $error_email,
        $error_user_exists
    ) {
        $this->errors = $errors;
        $this->error_password_text = $error_password_text;
        $this->error_password = $error_password;
        $this->error_email = $error_email;
        $this->error_user_exists = $error_user_exists;
        $content = '';
        
        $ueberschrift_gross = str_replace(
            "\n",
            '<br />',
            htmlspecialchars($this->pi_getFFvalue($this->settings, 'ueberschrift_gross'))
        );
        if ($ueberschrift_gross) {
            $content .= '<div class="register_header">';


            $content .= '<div class="register_header_right">
<h1 class="register_header">
' . $ueberschrift_gross . '
</h1>
</div>
        <div class="header_border_bottom">&nbsp;</div>
</div>';
        }



        $content .= '
<div class="account_temp_new">
<h3 class="account_login">' . htmlspecialchars($this->pi_getFFvalue($this->settings, 'ueberschrift_rot')) . '</h3>
' . $this->parseRTE($this->pi_getFFvalue($this->settings, 'einleitungstext')) . '';
        if ($this->errors) {
            $content .= '<div class="register-msg-error floatbox">';
            if ($this->error_user_exists) {
                $link = $this->pi_getPageLink(2046, '', [
                    'tx_felogin_pi1[forgot]' => '1',
                ]);
                $content .= '<div class="error-line" style="color: #e20813;">E-Mail Adresse existiert bereits. &nbsp;<a href="' . $link . '" class="link-passwort-vergessen">Passwort vergessen?</a></div>';
            }
            if ($this->error_email) {
                $content .= '<div class="error-line" style="color: #e20813;">Ungültige E-Mail-Adresse</div>';
            }
            if ($this->error_password) {
                $content .= '<div class="error-line" style="color: #e20813;">' . $this->error_password_text . '</div>';
            }

            $content .= '</div>';
        }


        $action_id = $this->pi_getFFvalue($this->settings, 'settings_pidActionLink', 'thanks');
        $content .= '<form class="form-kontakt" action="' . $this->pi_getPageLink(
            $action_id > 0 ? $action_id : $GLOBALS['TSFE']->id
        ) . '" method="post">
<input type="hidden" name="' . $this->prefixId . '[sendcode]" value="' . $this->sendcode . '" />
<fieldset>
<div class="fancyInput ig-inline ym-g100 floatbox account_register_line account_register_email' . ($this->error_email || $this->error_user_exists ? ' anmeldung-error' : '') . '">
<label class="reg-label">E-Mail-Adresse* (dies ist gleichzeitig Ihr Benutzername)</label>
<input class="fancyElement" type="text" name="' . $this->prefixId . '[e]" value="' . htmlspecialchars(
            $this->piVars['e']
        ) . '" />
</div>';
        foreach ($this->form_felder_1 as $name => $val) {
            $el_content = '';
            $el_content2 = '';
            switch ($val['type']) {
                case 'password':
                    $el_content = '<input class="fancyElement" type="password" name="' . $this->prefixId . '[' . $name . ']" value="' . htmlspecialchars(
                        $this->piVars[$name]
                    ) . '" /><br />';
                    $el_content2 .= '<input class="fancyElement" type="password" name="' . $this->prefixId . '[' . $name . '2]" value="' . htmlspecialchars(
                        $this->piVars[$name . '2']
                    ) . '" />';
                    break;
                default:
                    $el_content = '<input class="fancyElement" type="text" name="' . $this->prefixId . '[' . $name . ']" value="' . htmlspecialchars(
                        $this->piVars[$name]
                    ) . '" />';
            }
            if ($el_content) {
                $content .= '<div class="fancyInput ig-inline ym-g100 floatbox account_register_line' . ($this->error_password ? ' anmeldung-error' : '') . '">
<label class="reg-label">' . htmlspecialchars(
                    $val['label']
                ) . ($val['mandatory'] ? '*' : '') . ' (Mindestlänge 6 Zeichen)</label>
' . $el_content . (($val['description'] ?? false) ? ' ' . htmlspecialchars($val['description']) : '') . '
</div>';
            }
            if ($el_content2) {
                $content .= '<div class="fancyInput ig-inline ym-g100 floatbox account_register_line' . ($this->error_password ? ' anmeldung-error' : '') . '">
<label class="reg-label">Passwort wiederholen*</label>
' . $el_content2 . '
</div>';
            }
        }
        $content .= '<div class="ig-inline ym-g100" id="register-submit">
<input type="submit" name="submit" value="Registrieren" />
 </div>
</fieldset>
</form>
<br />
</div>

';

        return $content;
    }




    public function get_register_form_2()
    {
        $ueberschrift_gross = str_replace(
            "\n",
            '<br />',
            htmlspecialchars($this->pi_getFFvalue($this->settings, 'ueberschrift_gross'))
        );
        if ($ueberschrift_gross) {
            $content = '<div class="register_header">';

            $content .= '<div class="register_header_right">
<h1 class="register_header">
' . $ueberschrift_gross . '
</h1>
</div>
        <div class="header_border_bottom">&nbsp;</div>
</div>';
        }



        $content .= '
<div class="account_temp_new">
<h3 class="account_login">' . htmlspecialchars($this->pi_getFFvalue($this->settings, 'ueberschrift_rot')) . '</h3>
' . $this->parseRTE($this->pi_getFFvalue($this->settings, 'einleitungstext')) . '';
        if ($this->errors) {
            $content .= '<div class="register-msg-error floatbox">';
            if ($this->error_user_exists) {
                $link = $this->pi_getPageLink(2327, '', [
                    'tx_felogin_pi1[forgot]' => '1',
                ]);
                $content .= '<div class="error-line">E-Mail Adresse existiert bereits. &nbsp;<a href="' . $link . '" class="link-passwort-vergessen">Passwort vergessen?</a></div>';
            }
            if ($this->error_mandatory) {
                $content .= '<div class="error-line">Nicht alle zwingenden Felder sind ausgefüllt</div>';
            }
            if ($this->error_agb) {
                $content .= '<div class="error-line">Sie müssen die Teilnahmebedingungen bestätigen</div>';
            }

            $content .= '</div>';
        }


        $action_id = $this->pi_getFFvalue($this->settings, 'settings_pidActionLink', 'thanks');
        $email = $this->piVars['e'] ? $this->piVars['e'] : $row['username'];

        $content .= '<form action="' . $this->pi_getPageLink(
            $action_id > 0 ? $action_id : $GLOBALS['TSFE']->id
        ) . '" method="post">
<input type="hidden" name="' . $this->prefixId . '[sendcode]" value="' . $this->sendcode . '" />
<input type="hidden" name="' . $this->prefixId . '[uid]" value="' . $row['uid'] . '" />
<input type="hidden" name="h" value="' . htmlspecialchars($hash) . '" />
<fieldset>
<div class="floatbox account_register_line account_register_email' . ($this->error_email ? ' anmeldung-error' : '') . '">
<label class="reg-label">E-Mail *</label>
<div class="reg-input">' . htmlspecialchars($email) . '</div>
</div>';
        foreach ($this->form_felder_2 as $name => $val) {
            $content .= '<div class="floatbox account_register_line' . ($this->errors && !$this->piVars[$name] ? ' anmeldung-error' : '') . '">
<label class="reg-label">' . htmlspecialchars($val['label']) . ($val['mandatory'] ? ' *' : '') . '</label>
<div class="reg-input"><input type="text" name="' . $this->prefixId . '[' . $name . ']" value="' . htmlspecialchars(
                $this->piVars[$name]
            ) . '" /></div>
</div>';
        }

        $content .= '<div class="cahback_register_checkbox' . ($this->error_agb ? ' anmeldung-error' : '') . '">
<input type="checkbox" name="' . $this->prefixId . '[agb]" value="1" ' . ($this->piVars['agb'] == 1 ? 'checked="checked"' : '') . ' /> <span class="checkbox_text">' . htmlspecialchars(
            $this->pi_getFFvalue($this->settings, 'text_agb')
        ) . ' <a href="' . $this->pi_getFFvalue(
            $this->settings,
            'agb_link'
        ) . '" target="_blank">' . htmlspecialchars(
            $this->pi_getFFvalue($this->settings, 'text_agb_link')
        ) . '</a></span>
</div>';
        /*
          $content .= '<div class="cahback_register_checkbox">
          <input type="checkbox" name="' . $this->prefixId . '[newsletter]" value="1" '.($this->piVars['newsletter']==1 ? 'checked="checked"' : '').' /><span class="checkbox_text">'.htmlspecialchars($this->pi_getFFvalue($this->settings, 'text_newsletter')).'</span>
          </div>';
        */

        $content .= '<div id="register-submit">
<input type="submit" name="submit" value="' . htmlspecialchars(
            $this->pi_getFFvalue($this->settings, 'text_knopf')
        ) . '" />
 </div>
</fieldset>
</form>
<br />
</div>

';

        return $content;
    }




    public function init($arguments, $settings, $sendcode)
    {
        //$this->id = $this->cObj->data ['_LOCALIZED_UID']  ? $this->cObj->data ['_LOCALIZED_UID'] : $this->cObj->data ['uid');
        $this->piVars = $arguments;
        $this->settings = $settings;

        $this->sendcode = $sendcode;
        $this->errors = 0;
    }

    private function pi_getFFvalue($settings, $name, $tab = '')
    {
        if ($tab) {
            return $settings[$tab][$name];
        }
        return $settings[$name];
    }
    private function pi_getPageLink($pageUid, $target = '', $args = [])
    {
        return '';
    }
}
