<?php

use \TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Core\Crypto\PasswordHashing\PasswordHashFactory;
use \TYPO3\CMS\Frontend\ContentObject\ContentObjectRenderer;

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2014 Daniel Abplanalp <typo3@internetgalerie.ch>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

// ////require_once(PATH_tslib . 'class.tslib_pibase.php');

/**
 * Plugin 'Create Account Form' for the 'ig_account_create' extension.
 *
 * @author	Daniel Abplanalp <typo3@internetgalerie.ch>
 * @package	TYPO3
 * @subpackage	tx_igaccountcreate
 */
class tx_igaccountcreate_pi1 extends \TYPO3\CMS\Frontend\Plugin\AbstractPlugin {
	public $prefixId      = 'tx_igaccountcreate_pi1';		// Same as class name
	public $scriptRelPath = 'pi1/class.tx_igaccountcreate_pi1.php';	// Path to this script relative to the extension dir.
	public $extKey        = 'ig_account_create';	// The extension key.

	private $secret = 'G%rT4*D7EjdhKDFw-.,Fpo)d0';
	private $baseurl;

	public $form_felder_1 = array(
				    'p' => array (
						     'label' => 'Passwort',
						     'type' => 'password',
						     'mandatory' => 1,
						     ),
				    );
	public $form_felder_2 = array(
				    'name' => array (
						     'label' => 'Name',
						     'mandatory' => 1,
						     ),
				    'vorname' => array (
						     'label' => 'Vorname',
						     'mandatory' => 1,
						     ),
				    'strasse' => array (
						     'label' => 'Strasse',
						     'mandatory' => 1,
						     ),
				    'plz' => array (
						     'label' => 'PLZ',
						     'mandatory' => 1,
						     ),
				    'ort' => array (
						     'label' => 'Ort',
						     'mandatory' => 1,
						     ),
				    'telefon' => array (
						     'label' => 'Telefon',
						     'mandatory' => 1,
						     'description' => '(Wichitg für kurzfristige Kursabsagen)',
						     ),
				    'mobile' => array (
						     'label' => 'Natel',
						     'mandatory' => 0,
						     'description' => '(Wichitg für kurzfristige Kursabsagen)',
						     ),
				    );
                    
    function parseRTE( $value ) {
        $parseFuncTSPath='lib.parseFunc_RTE';
        $contentObject = GeneralUtility::makeInstance(ContentObjectRenderer::class);
        $contentObject->start([]);
        $content = $contentObject->parseFunc($value, [], '< ' . $parseFuncTSPath);
        return $content;
    }

    function generatePassword($len = 8, $list = '23456789ABCDEFGHJKMNPQRSTUVWXYZ') {
        $str = '';
        if (is_numeric ($len) && !empty ($list)) {
            mt_srand ((double) microtime () * 1000000);
            while (strlen ($str) < $len) {
                $str .= $list[mt_rand (0, strlen ($list)-1)];
            }
        }
        return $str;
    }

    function createuser($email, $password, $hash, $newsleter) {
        $hashFactory = GeneralUtility::makeInstance(PasswordHashFactory::class);
        $hashInstance = $hashFactory->getDefaultHashInstance('FE');
        $hashedPassword=$hashInstance->getHashedPassword( $password );

        $insertArray = array(
                             'pid'               => $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'settings_pidUsers', 'sThanks'),
                             'usergroup'         => $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'settings_usergroup', 'sThanks'),
                             'username'          => $email,
                             'password'          => $hashedPassword,
                             'email'             => $email,
                             'disable'           => 1,
                             'tstamp'            => time(),
                             'crdate'            => time(),
			     'tx_extbase_type'   => 'Tx_IgFemanager_FeUserExtendet',
			     'comments'          => $hash,
                             );
	/*        if ( $newsleter ) {
            $insertArray['module_sys_dmail_newsletter'] = 1;
            $insertArray['module_sys_dmail_html'] = 1;

        }
	*/
           
        $res = $GLOBALS['TYPO3_DB']->exec_INSERTquery('fe_users', $insertArray);

    }

	/**
	 * renders fluid template
	 * @param string $template path to fluid-html-template, form: ext/Resources/Private/Templates/*$template*
	 * @param array $parameter key=>value pairs, where key is fluid placeholder {key} in the template
	 * @return string rendered (html-format) template
	 */
	private function renderFluid($template, $parameter) {
		/**
		 * @var \TYPO3\CMS\Fluid\View\StandaloneView $emailView
		 */
		$objectManager = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('TYPO3\\CMS\\Extbase\\Object\\ObjectManager');
		$fluidView = $objectManager -> get('TYPO3\\CMS\\Fluid\\View\\StandaloneView');
		$extPath = \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath($this->extKey);
		$templateFile = $extPath . "Resources/Private/Templates/" . $template;
		$partialOrder = $extPath . "Resources/Private/Partials/";
		$fluidView -> setTemplatePathAndFilename($templateFile);
		$fluidView -> setPartialRootPaths([$partialOrder]);
		$fluidView -> assignMultiple($parameter);
		$fluidView -> getRequest() -> setControllerExtensionName("ig_account_create");
		return $fluidView -> render("index");
	}

	public function getMailText($params = array()) {
		
		$params['baseUrl'] = $this->baseurl;
		
		//echo $this -> renderFluid("Mail/Index.html", $params); exit;
		
		return $this -> renderFluid("Mail/Index.html", $params);
		
	}


    function sendmail($email, $password, $hash/*, $valid_to*/) {
        
        //$endtime= date("d.m.Y - H:i", $valid_to);
        $msg = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'email_text', 'sThanks');
        
        $msg = str_replace('###USERNAME###',$email,$msg);
        $msg = str_replace('###PASSWORD###',$password,$msg);

        $username_password = '<table><tr><td style="font-size:10pt;font-family:arial;padding-left: 0;">Benutzername:</td><td>&nbsp;</td><td style="font-size:10pt;font-family:arial;;padding-left: 0;">'.htmlspecialchars($email).'</td></tr>
<tr><td style="font-size:10pt;font-family:arial;;padding-left: 0;">Passwort:</td><td>&nbsp;</td><td style="font-size:10pt;font-family:arial;;padding-left: 0;">'.htmlspecialchars($password).'</td></tr></table>';
        $msg = str_replace('###USERNAME_PASSWORD###',$username_password,$msg);

        $msg = str_replace('###LOGIN_LINK###','<a href="'.$this->baseurl.'de/login.html">'.$this->baseurl.'de/login.html</a>',$msg);
        $msg = str_replace('###CONFIRM_LINK###','<a href="'.$this->baseurl.'de/registrieren/bestaetigungsseite.html?h='.urlencode($hash).'">'.$this->baseurl.'de/registrieren/bestaetigungsseite.html?tx_igaccountcreate_pi1[send]=1&h='.urlencode($hash).'</a>',$msg);
        $msg = str_replace('###EMAIL_LINK###','<a href="mailto:'.$this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'email_from', 'sThanks').'">'.$this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'email_from', 'sThanks').'</a>',$msg);



        // Mail Verschicken
        $cObj = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance ( "TYPO3\CMS\Frontend\ContentObject\ContentObjectRenderer" );
        $parseFunc = $GLOBALS ['TSFE']->tmpl->setup ['lib.'] ['parseFunc_RTE.'];
		$contact =  array("Nähcenter Iseli AG",
					"Oberlandstrasse 17",
					"3700 Spiez",
					"Telefon +41 33 654 34 84");
		
        $mail = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance(\TYPO3\CMS\Core\Mail\MailMessage::class);
		$parameter = array(
			"msg" => $cObj->parseFunc ( $msg, $parseFunc ),
			"logo" => 'fileadmin/layout/images_layout/naehcenter-iseli.jpg',
			"contact" => $contact,
			"baseUrl" => $this->baseurl,
		);
        /*var_dump($parameter);
        die();*/
        $body = $this->renderFluid("Mail/Index.html", $parameter);
        $mail->setFrom(array($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'email_from', 'sThanks')));
        $mail->setTo(array($email));
        $mail->setSubject($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'email_subject', 'sThanks'));
        $mail->setBody($body, 'text/html');
        $mail->send();

	// Debug
	/*
        $mail->setTo(array('da@internetgalerie.ch'));
        $mail->send();
	*/

        /*        $this->htmlMail = \TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('t3lib_htmlmail');
        $this->htmlMail->start();
        $this->htmlMail->recipient = $email;
        $this->htmlMail->subject = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'email_subject', 'sThanks');
        $this->htmlMail->from_email = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'email_from', 'sThanks');

        $body = '<html>'.$this->html_head.'<body><div style="font-size:10pt;font-family:arial;">' .$msg. '</div></body></html>';
        $this->htmlMail->setHTML(  $this->htmlMail->encodeMsg ( $body ));
        //print('MSG<br />'.$msg.'<br />END<br />');
        $this->htmlMail->send($email);
        */

    }


    function get_register_form_1() {
      //DADA MUSS rein
      //        $dam = tx_dam_db::getReferencedFiles ( 'tt_content', $this->id, 'ig_account_register_bild_links' );
        $bild = '';
        foreach ( ( array ) $dam ['files'] as $df ) {
            $bild =$df;
        }

        $ueberschrift_gross = str_replace("\n",'<br />',htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'ueberschrift_gross')));
        if ($ueberschrift_gross) {
        $content ='<div class="register_header">';

        if ($bild) {
/*            $content .= '<div class="register_header_left">
<img src="'.$bild.'" />
</div>';*/
        }

$content .= '<div class="register_header_right">
<h1 class="register_header">
'.$ueberschrift_gross.'
</h1>
</div>
        <div class="header_border_bottom">&nbsp;</div>
</div>';
        }



		$content .= '
<div class="account_temp_new">
<h3 class="account_login">'.htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'ueberschrift_rot')).'</h3>
'.$this->parseRTE($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'einleitungstext')).'';
        if ($this->errors) {
            $content .= '<div class="register-msg-error floatbox">';
            if ($this->error_user_exists) {
                $link = $this->pi_getPageLink(2046, '', array( 'tx_felogin_pi1[forgot]' => '1' ) );
                $content .= '<div class="error-line" style="color: #e20813;">E-Mail Adresse existiert bereits. &nbsp;<a href="' . $link .'" class="link-passwort-vergessen">Passwort vergessen?</a></div>';

            }
            if ($this->error_email)
                $content .= '<div class="error-line" style="color: #e20813;">Ungültige E-Mail-Adresse</div>';
	    if ($this->error_password) 
                $content .= '<div class="error-line" style="color: #e20813;">'.$this->error_password_text.'</div>';

            $content .= '</div>';
        }


        $action_id = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'settings_pidActionLink', 'sThanks');
        $content .= '<form class="form-kontakt" action="' . $this->pi_getPageLink( $action_id>0 ? $action_id : $GLOBALS['TSFE']->id ) . '" method="post">
<input type="hidden" name="' . $this->prefixId . '[sendcode]" value="'.$this->sendcode.'" />
<fieldset>
<div class="fancyInput ig-inline ym-g100 floatbox account_register_line account_register_email'. ( $this->error_email || $this->error_user_exists ? ' anmeldung-error' : '' ) .'">
<label class="reg-label">E-Mail-Adresse* (dies ist gleichzeitig Ihr Benutzername)</label>
<input class="fancyElement" type="text" name="' . $this->prefixId . '[e]" value="' . htmlspecialchars($this->piVars['e']) . '" />
</div>';
	foreach( $this->form_felder_1 as $name=>$val) {
	  $el_content='';
	  $el_content2='';
	  switch($val['type']) {
	  case 'password':
	    $el_content = '<input class="fancyElement" type="password" name="' . $this->prefixId . '['.$name.']" value="' . htmlspecialchars($this->piVars[$name]) . '" /><br />';
	    $el_content2 .= '<input class="fancyElement" type="password" name="' . $this->prefixId . '['.$name.'2]" value="' . htmlspecialchars($this->piVars[$name.'2']) .'" />';
	  break;
	  default:
	    $el_content = '<input class="fancyElement" type="text" name="' . $this->prefixId . '['.$name.']" value="' . htmlspecialchars($this->piVars[$name]) . '" />';
	}
	  if ($el_content) {
	    $content .= '<div class="fancyInput ig-inline ym-g100 floatbox account_register_line'. ( $this->error_password ? ' anmeldung-error' : '' ) .'">
<label class="reg-label">'.htmlspecialchars($val['label']).($val['mandatory'] ? '*' : '' ) . ' (Mindestlänge 6 Zeichen)</label>
'. $el_content . ($val['description'] ? ' ' . htmlspecialchars($val['description']) : '') . '
</div>';
	  }
	  if ($el_content2) {
	    $content .= '<div class="fancyInput ig-inline ym-g100 floatbox account_register_line'. ( $this->error_password ? ' anmeldung-error' : '' ) .'">
<label class="reg-label">Passwort wiederholen*</label>
'. $el_content2 . '
</div>';
	  }
	  
	}
	 $content .= '<div class="ig-inline ym-g100" id="register-submit">
<input type="submit" name="submit" value="Registrieren" />
 </div>
</fieldset>
</form>
<br />
</div>

';

        return $content;
    }




    function get_register_form_2() {
      
      $hash = $_REQUEST['h'];
      //echo('h='.$hash);
      if(strlen($hash)<10)
	return 'Ungültiger Link';

      $con=$GLOBALS['TYPO3_DB']->exec_SELECTquery( '*', 'fe_users', "deleted = 0 AND comments=".$GLOBALS['TYPO3_DB']->fullQuoteStr($hash,'fe_users')."", null,  null, null );
      if (!($row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc( $con ))) {
	return 'Ungültiger Link';
      }

	    
      // DADA muss rein
      //$dam = tx_dam_db::getReferencedFiles ( 'tt_content', $this->id, 'ig_account_register_bild_links' );
        $bild = '';
        foreach ( ( array ) $dam ['files'] as $df ) {
            $bild =$df;
        }

        $ueberschrift_gross = str_replace("\n",'<br />',htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'ueberschrift_gross')));
        if ($ueberschrift_gross) {
        $content ='<div class="register_header">';

        if ($bild) {
/*            $content .= '<div class="register_header_left">
<img src="'.$bild.'" />
</div>';*/
        }

$content .= '<div class="register_header_right">
<h1 class="register_header">
'.$ueberschrift_gross.'
</h1>
</div>
        <div class="header_border_bottom">&nbsp;</div>
</div>';
        }



		$content .= '
<div class="account_temp_new">
<h3 class="account_login">'.htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'ueberschrift_rot')).'</h3>
'.$this->parseRTE($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'einleitungstext')).'';
        if ($this->errors) {
            $content .= '<div class="register-msg-error floatbox">';
            if ($this->error_user_exists) {
                $link = $this->pi_getPageLink(2327, '', array( 'tx_felogin_pi1[forgot]' => '1' ) );
                $content .= '<div class="error-line">E-Mail Adresse existiert bereits. &nbsp;<a href="' . $link .'" class="link-passwort-vergessen">Passwort vergessen?</a></div>';

            }
            if ($this->error_mandatory)
                $content .= '<div class="error-line">Nicht alle zwingenden Felder sind ausgefüllt</div>';
            if ($this->error_agb)
                $content .= '<div class="error-line">Sie müssen die Teilnahmebedingungen bestätigen</div>';

            $content .= '</div>';
        }


        $action_id = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'settings_pidActionLink', 'sThanks');
	$email = $this->piVars['e'] ? $this->piVars['e'] : $row['username'];

        $content .= '<form action="' . $this->pi_getPageLink( $action_id>0 ? $action_id : $GLOBALS['TSFE']->id ) . '" method="post">
<input type="hidden" name="' . $this->prefixId . '[sendcode]" value="'.$this->sendcode.'" />
<input type="hidden" name="' . $this->prefixId . '[uid]" value="'.$row['uid'].'" />
<input type="hidden" name="h" value="'.htmlspecialchars($hash).'" />
<fieldset>
<div class="floatbox account_register_line account_register_email'. ( $this->error_email ? ' anmeldung-error' : '' ) .'">
<label class="reg-label">E-Mail *</label>
<div class="reg-input">' . htmlspecialchars($email) . '</div>
</div>';
	foreach( $this->form_felder_2 as $name=>$val) {
	  $content .= '<div class="floatbox account_register_line'. ( $this->errors && ! $this->piVars[$name] ? ' anmeldung-error' : '' ) .'">
<label class="reg-label">'.htmlspecialchars($val['label']). ($val['mandatory'] ? ' *' : '' ) . '</label>
<div class="reg-input"><input type="text" name="' . $this->prefixId . '['.$name.']" value="' . htmlspecialchars($this->piVars[$name]) . '" /></div>
</div>';
	}

	  $content .= '<div class="cahback_register_checkbox'. ( $this->error_agb ? ' anmeldung-error' : '' ) .'">
<input type="checkbox" name="' . $this->prefixId . '[agb]" value="1" '.($this->piVars['agb']==1 ? 'checked="checked"' : '').' /> <span class="checkbox_text">'.htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'text_agb')) .' <a href="'.$this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'agb_link').'" target="_blank">' . htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'text_agb_link')).'</a></span>
</div>';
	  /*
	  $content .= '<div class="cahback_register_checkbox">
<input type="checkbox" name="' . $this->prefixId . '[newsletter]" value="1" '.($this->piVars['newsletter']==1 ? 'checked="checked"' : '').' /><span class="checkbox_text">'.htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'text_newsletter')).'</span>
</div>';
	  */

	 $content .= '<div id="register-submit">
<input type="submit" name="submit" value="'.htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'text_knopf')).'" />
 </div>
</fieldset>
</form>
<br />
</div>

';

        return $content;
    }



    function get_register_send_mail() {

        $email = $this->piVars['e'];
        $password = $this->piVars['p'];//$this->generatePassword();
        $newsletter = intval($this->piVars['newsletter']);

	$hash= md5($this->secret . $email . strval(time()));

        // Create User
        $this->createuser($email, $password, $hash, $newsletter);
        // Send Mail
        $this->sendmail($email, $password, $hash);



        $content = '<div class="account_temp_new">
<h3 class="account_login">'.htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'ueberschrift_rot', 'sThanks')).'</h3>
'.$this->parseRTE($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'einleitungstext', 'sThanks')).'
</div>';

        return $content;
    }

    function update_register_form_2() {
      $content = '';
      $hash = $_REQUEST['h'];
      
      $table = 'fe_users';
      $where = "comments<>'' AND comments = ".$GLOBALS['TYPO3_DB']->fullQuoteStr($hash, $table);
      $fields_values = array(
			    /*'first_name' => $this->piVars['vorname'],
			     'last_name' => $this->piVars['name'],
			     'zip' => $this->piVars['plz'],
			     'city' => $this->piVars['ort'],
			     'telephone' => $this->piVars['telefon'],
			     //'mobile' => $this->piVars['mobile'],
			     'address' => $this->piVars['strasse'],*/
			     'disable' => '0',
			     'comments' => '',
			     );
      $res = $GLOBALS['TYPO3_DB']->exec_UPDATEquery($table, $where, $fields_values);
      $affected_rows = $GLOBALS['TYPO3_DB']->sql_affected_rows();
      if ($affected_rows==1) {
	$content = '<h3 class="account_login">'.htmlspecialchars($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'ueberschrift_rot', 'sThanks')).'</h3>
'.$this->parseRTE($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'einleitungstext', 'sThanks')).'';
      } else {
	$content = '<h3>Die Erfassung der Daten ist fehlgeschlagen</h3>';
      }
      $content .= '<p><a href="'.$this->pi_getPageLink(2046).'">Weiter zum Login</a></p>';
      return $content;
    }


	
	/**
	 * The main method of the Plugin.
	 *
	 * @param string $content The Plugin content
	 * @param array $conf The Plugin configuration
	 * @return string The content that is displayed on the website
	 */
    public function main($content, array $conf) {
      $this->conf = $conf;
      $this->pi_setPiVarDefaults();
      $this->pi_loadLL();
      $this->pi_USER_INT_obj = 1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!
      $this->pi_initPIflexForm();
	  $this->baseurl = \TYPO3\CMS\Core\Utility\GeneralUtility::getIndpEnv('TYPO3_SITE_URL');
      $hash = $_REQUEST['h'];
      $this->id = $this->cObj->data ['_LOCALIZED_UID']  ? $this->cObj->data ['_LOCALIZED_UID'] : $this->cObj->data ['uid'];
      
      $t = round(strftime('%s')/3600);
      
      $this->sendcode = md5($t.$this->hash_string);
      $this->sendcode_old = md5(($t-1).$this->hash_string);
      

      
      $this->errors = 0;
      
      // Token gueltig?
      //if ($this->piVars['h'] && ($this->piVars['h']==$this->sendcode || $this->piVars['h']==$this->sendcode_old)) {
  	if (strlen($_REQUEST['h']) > 10 || ($this->piVars['sendcode']==$this->sendcode || $this->piVars['sendcode']==$this->sendcode_old)) {
		$send=1;
      } else{
      	$send=0;
      }

      $mode = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'mode', 'sDEF');

      if ( $mode=='account_create_1' ) {
	//echo('errors:'.$this->errors.' send:'.$send.'<br />');
	if ($send) {
	  $this->error_email = 0;
	  $this->error_password = 0;
	  $this->error_user_exists = 0;
	  
	  // Ist E-Mail gueltig
	  $con=$GLOBALS['TYPO3_DB']->exec_SELECTquery( '*', 'fe_users', "deleted = 0 AND comments=".$GLOBALS['TYPO3_DB']->fullQuoteStr($hash,'fe_users')."", null,  null, null );
	  if (!filter_var($this->piVars['e'],FILTER_VALIDATE_EMAIL))
	    $this->error_email = 1;
	  
	  // Existiert der Benutzer schon
	  $email=$this->piVars['e'];
	  if ($this->error_email==0) {
	    $con=$GLOBALS['TYPO3_DB']->exec_SELECTquery( 'uid', 'fe_users', "deleted = 0 AND email=".$GLOBALS['TYPO3_DB']->fullQuoteStr($email,'fe_users')."", null,  null, null );
	    $row=$GLOBALS['TYPO3_DB']->sql_fetch_assoc( $con );
	    
	    if (!empty($row)) {
	      //$update_tmp=$GLOBALS['TYPO3_DB']->exec_UPDATEquery('fe_users',"deleted = 0 AND email=". $GLOBALS['TYPO3_DB']->fullQuoteStr($email,'fe_users')."", array( 'endtime' => 0));
	      $this->error_user_exists = 1;                
	    }
	  }

	  if ( $this->piVars['p']!=$this->piVars['p2']) {
	    $this->error_password_text='Die beiden Passwörter sind nicht gleich';
	    $this->error_password = 1;
	  } elseif( strlen($this->piVars['p'])<6 ) {
	    $this->error_password = 1;
	    $this->error_password_text='Das Passwort muss mindestens 6 Zeichen lang sein';
	  }
	  $this->errors = $this->error_email || $this->error_password ||  $this->error_user_exists;
	}
	
	if (!$this->errors && $send==1) {
	  $content = $this->get_register_send_mail();
	} else {
	  $content = $this->get_register_form_1();
	}
      } else {
	// Formular 2
	// Felder testen
        if ($send) 
	    $this->error_agb = 0;

	  $this->errors =  $this->errors || $this->error_agb ;
	if (!$this->errors && $send==1) {
	  $content = $this->update_register_form_2();
	} else {
	  $content = $this->get_register_form_2();
	}
      }
      
      return $this->pi_wrapInBaseClass($content);
    }
    
    
    
  }



if (defined('TYPO3_MODE') && isset($GLOBALS['TYPO3_CONF_VARS'][TYPO3_MODE]['XCLASS']['ext/ig_account_create/pi1/class.tx_igaccountcreate_pi1.php'])) {
  include_once($GLOBALS['TYPO3_CONF_VARS'][TYPO3_MODE]['XCLASS']['ext/ig_account_create/pi1/class.tx_igaccountcreate_pi1.php']);
}

?>